% !TEX root = ../main.tex

%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% For reviewing

\newcommand{\change}[2]{{\color{red}#1}{\color{green!50!black}#2}}
\newcommand{\remove}[1]{{\color{red}#1}}
\newcommand{\add}[1]{{\color{green!50!black}#1}}
\newcommand{\question}[1]{\textbf{\color{red}[Erika: #1]}}
\newcommand{\answer}[1]{{\color{blue100}[\textbf{Gereon:} #1]}}

%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Alphabets

\DeclareMathAlphabet\mathbfcal{OMS}{cmsy}{b}{n}

%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Math symbols

\newcommand{\A}{\mathcal{A}}

\newcommand{\B}{\ensuremath{\mathbb{B}}\xspace}
\newcommand{\Basis}{\ensuremath{\mathcal{B}}\xspace}
\newcommand{\BAbs}{\ensuremath{\varphi_{abs}}\xspace}

\newcommand{\BoundL}[1]{\underaccent{\tilde}{#1}}
\newcommand{\BoundU}[1]{\tilde{#1}}

\newcommand{\Clauses}{\ensuremath{\mathcal{C}}\xspace}
\newcommand{\Conflicts}{\mathrel{\mathop\Vdash}}

\newcommand{\LT}{\ensuremath{\mathcal{L}}\xspace}

\newcommand{\N}{\ensuremath{\mathbb{N}}\xspace}

\newcommand{\Powerset}{\ensuremath{\mathscr{P}}\xspace}
\newcommand{\ProofSystem}{\ensuremath{\mathbfcal{P}}\xspace}

\newcommand{\Q}{\ensuremath{\mathbb{Q}}\xspace}

\newcommand{\R}{\mathbb{R}}
\newcommand{\Rat}{\mathbb{Q}}

\newcommand{\T}{\mathcal{T}}

\newcommand{\Z}{\mathbb{Z}}

%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Math operators

% generic math
\DeclareMathOperator{\lxor}{\oplus}
\DeclareMathOperator{\sgn}{sgn}
\DeclareMathOperator*{\argmax}{arg\,max}
\DeclareMathOperator*{\argmin}{arg\,min}
\DeclareMathOperator{\PlusEQ}{\raisebox{-.75pt}{\textrm{\texttt{+=}}}}
\DeclareMathOperator{\MinEQ}{\raisebox{-.75pt}{\textrm{\texttt{-=}}}}
\DeclareMathOperator*{\DisjointUnion}{\mathaccent\cdot\cup}
\newcommand{\restrict}[1]{|_{#1}}


% polynomial operators
\DeclareMathOperator{\Coeffs}{coeffs}
\DeclareMathOperator{\Degree}{deg}
\DeclareMathOperator{\TDegree}{tdeg}
\DeclareMathOperator{\Lcoeff}{lcoeff}
\DeclareMathOperator{\Lterm}{lterm}
\DeclareMathOperator{\Tcoeff}{tcoeff}
\DeclareMathOperator{\Content}{cont}
\DeclareMathOperator{\Primitive}{prim}
\DeclareMathOperator{\Disc}{disc}
\DeclareMathOperator{\Res}{res}

% special functions
\DeclareMathOperator{\Kern}{kern}
\DeclareMathOperator{\Image}{image}
\DeclareMathOperator{\Consistent}{consistent}
\DeclareMathOperator{\Explain}{explain}
\DeclareMathOperator{\Infeasible}{infeasible}
\DeclareMathOperator{\Resolution}{Resolution}
\DeclareMathOperator{\Value}{value}
\DeclareMathOperator{\Sign}{sgn}
\DeclareMathOperator{\Root}{root}
\DeclareMathOperator{\Roots}{roots}
\DeclareMathOperator{\Factors}{factors}
\DeclareMathOperator{\Projection}{proj}

% proof complexity operators
\DeclareMathOperator*{\PCGT}{\texorpdfstring{\succ}{> }}
\DeclareMathOperator*{\PCGEQ}{\texorpdfstring{\curlyeqsucc}{>= }}
\DeclareMathOperator*{\PCEQ}{\texorpdfstring{\approxeq}{= }}

\DeclareMathOperator*{\BSGEQ}{\texorpdfstring{\ensuremath{\succeq}\xspace}{>= }}
\DeclareMathOperator*{\BSEQ}{\texorpdfstring{\simeq}{= }}
\DeclareMathOperator*{\StateEQ}{\texorpdfstring{\backsimeq}{= }}

\newcommand{\Seq}[1]{\llbracket #1 \rrbracket}
\newcommand{\State}[1]{\langle #1 \rangle}
\newcommand{\Exists}[1]{\ensuremath{\exists #1.~}}
\newcommand{\Forall}[1]{\ensuremath{\forall #1.~}}
\newcommand{\Quantifier}[1]{\ensuremath{Q #1.~}}


%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Special symbols

\newcommand{\false}{\ensuremath{\mathit{false}}\xspace}
\newcommand{\true}{\ensuremath{\mathit{true}}\xspace}
\newcommand{\Undef}{\ensuremath{\mathit{undef}}\xspace}

\DeclareMathOperator{\EquivTrue}{\stackrel{\true}{\sim}}
\DeclareMathOperator{\EquivFalse}{\stackrel{\false}{\sim}}

\newcommand{\CPP}{C\nolinebreak[4]\hspace{-.05em}\raisebox{.4ex}{\tiny\textbf{++}}\xspace}
\newcommand{\CDCL}{\texorpdfstring{\texttt{CDCL}\xspace}{CDCL }}
\newcommand{\CDCLT}{\texorpdfstring{\texttt{CDCL(T)}\xspace}{CDCL(T) }}
\newcommand{\CDCLST}{\texorpdfstring{\texttt{CDCL\!$^*$\!(T)}\xspace}{CDCL*(T) }}
\newcommand{\DPLL}{\texttt{DPLL}\xspace}
\newcommand{\DPLLT}{\texttt{DPLL(T)}\xspace}
\newcommand{\DPLLST}{\texttt{DPLL\!$^*$\!(T)}\xspace}
\newcommand{\MCSAT}{\texorpdfstring{\texttt{MCSAT}\xspace}{MCSAT }}
\newcommand{\NLSAT}{\texttt{NLSAT}\xspace}
\newcommand{\ResT}{\texorpdfstring{\texttt{Res(T)}\xspace}{Res(T) }}
\newcommand{\ResST}{\texorpdfstring{\texttt{Res$^*$\!(T)}\xspace}{Res*(T) }}

\newcommand{\Backtrack}{\texttt{Backtrack}\xspace}
\newcommand{\BCP}{\texttt{BCP}\xspace}
\newcommand{\Decide}{\texttt{Decide}\xspace}
\newcommand{\ResolveConflict}{\texttt{Resolve}\xspace}


\newcommand{\QFNRA}{\texttt{QF\_NRA}\xspace}
\newcommand{\QFNIA}{\texttt{QF\_NIA}\xspace}
\newcommand{\SCSquare}{SC$^2$\xspace}
\newcommand{\SMTCOMP}{SMT-COMP\xspace}
\newcommand{\SMTLIB}{SMT-LIB\xspace}

\newcommand{\AltErgo}{\texttt{Alt-Ergo}\xspace}
\newcommand{\AProVE}{\texttt{AProVE}\xspace}
\newcommand{\CArL}{\texttt{CArL}\xspace}
\newcommand{\CVC}{\texttt{CVC4}\xspace}
\newcommand{\MathSAT}{\texttt{MathSAT}\xspace}
\newcommand{\raSAT}{\texttt{raSAT}\xspace}
\newcommand{\Redlog}{\texttt{Redlog}\xspace}
\newcommand{\SMTRAT}{\texttt{SMT-RAT}\xspace}
\newcommand{\Vampire}{\texttt{Vampire}\xspace}
\newcommand{\veriT}{\texttt{veriT}\xspace}
\newcommand{\veriTRedlog}{\texttt{veriT+Redlog}\xspace}
\newcommand{\Yices}{\texttt{Yices}\xspace}
\newcommand{\Zthree}{\texttt{Z3}\xspace}


%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Proof rules

\newcommand{\rulename}[1]{\texttt{#1}}

% Typesets a proof rule within an align environment
% Arguments:
% 	1: Name of the rule
% 	2: Premise
% 	3: Conclusion
% 	4: Condition (to be put in an align environment)
\newcommand{\ProofRule}[4]{
	\ifx&#1& \else \shortintertext{\textrm{\textbf{\rulename{#1:}}}} \fi
 \inferrule{#2}{#3} && \ifx&#4& \else \textrm{ \textbf{if} } \fi & \begin{array}{l} #4 \end{array} \displaybreak[0]
}


%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Solver names

\newcommand{\SolverCADProjCollins}{\texttt{Collins}\xspace}
\newcommand{\SolverCADProjHong}{\texttt{Hong}\xspace}
\newcommand{\SolverCADProjMcCallum}{\texttt{McCallum}\xspace}
\newcommand{\SolverCADProjMcCallumPartial}{\texttt{McCallum-partial}\xspace}
\newcommand{\SolverCADProjLazard}{\texttt{Lazard}\xspace}
\newcommand{\SolverCADProjBrown}{\texttt{Brown}\xspace}

\newcommand{\SolverCADLOls}{\texttt{LO-ls}\xspace}
\newcommand{\SolverCADLOlt}{\texttt{LO-lt}\xspace}
\newcommand{\SolverCADLOlta}{\texttt{LO-lta}\xspace}
\newcommand{\SolverCADLOlts}{\texttt{LO-lts}\xspace}
\newcommand{\SolverCADLOltsa}{\texttt{LO-ltsa}\xspace}
\newcommand{\SolverCADLOs}{\texttt{LO-s}\xspace}
\newcommand{\SolverCADLOt}{\texttt{LO-t}\xspace}
\newcommand{\SolverCADLOtlsa}{\texttt{LO-tlsa}\xspace}
\newcommand{\SolverCADLOts}{\texttt{LO-ts}\xspace}
\newcommand{\SolverCADLOtsa}{\texttt{LO-tsa}\xspace}

\newcommand{\SolverCADPOd}{\texttt{PO-D}\xspace}
\newcommand{\SolverCADPOld}{\texttt{PO-LD}\xspace}
\newcommand{\SolverCADPOlld}{\texttt{PO-lD}\xspace}
\newcommand{\SolverCADPOpd}{\texttt{PO-PD}\xspace}
\newcommand{\SolverCADPOsd}{\texttt{PO-SD}\xspace}

\newcommand{\SolverCADIncNone}{\texttt{None}\xspace}
\newcommand{\SolverCADIncNaive}{\texttt{Naive}\xspace}
\newcommand{\SolverCADIncSimple}{\texttt{Simple}\xspace}
\newcommand{\SolverCADIncFull}{\texttt{Full}\xspace}

\newcommand{\SolverCADECHH}{\texttt{CAD-Hong}\xspace}
\newcommand{\SolverCADECECH}{\texttt{CAD-EC-Hong}\xspace}
\newcommand{\SolverCADECECSH}{\texttt{CAD-ECS-Hong}\xspace}
\newcommand{\SolverCADECHM}{\texttt{CAD-McCallum}\xspace}
\newcommand{\SolverCADECECM}{\texttt{CAD-EC-McCallum}\xspace}
\newcommand{\SolverCADECECSM}{\texttt{CAD-ECS-McCallum}\xspace}
\newcommand{\SolverCADECHB}{\texttt{CAD-Brown}\xspace}
\newcommand{\SolverCADECECB}{\texttt{CAD-EC-Brown}\xspace}
\newcommand{\SolverCADECECSB}{\texttt{CAD-ECS-Brown}\xspace}


\newcommand{\SolverCADPP}{\texttt{CAD}\xspace}
\newcommand{\SolverCADPPVE}{\texttt{CAD+VE}\xspace}
\newcommand{\SolverCADPPRR}{\texttt{CAD+RR}\xspace}
\newcommand{\SolverCADPPVERR}{\texttt{CAD+VE+RR}\xspace}
\newcommand{\SolverCADECSPP}{\texttt{CAD-ECS}\xspace}
\newcommand{\SolverCADECSPPVE}{\texttt{CAD-ECS+VE}\xspace}
\newcommand{\SolverCADECSPPRR}{\texttt{CAD-ECS+RR}\xspace}
\newcommand{\SolverCADECSPPVERR}{\texttt{CAD-ECS+VE+RR}\xspace}

\newcommand{\SolverCADMISExact}{\texttt{Exact}\xspace}
\newcommand{\SolverCADMISHybrid}{\texttt{Hybrid}\xspace}
\newcommand{\SolverCADMISGreedy}{\texttt{Greedy}\xspace}
\newcommand{\SolverCADMISGreedyPre}{\texttt{Greedy-PP}\xspace}
\newcommand{\SolverCADMISGreedyWeighted}{\texttt{Greedy-Weighted}\xspace}
\newcommand{\SolverCADMISTrivial}{\texttt{Trivial}\xspace}

\newcommand{\SolverCADNIAFull}{\texttt{NIA-Full}\xspace}
\newcommand{\SolverCADNIABB}{\texttt{NIA-B\&B}\xspace}
\newcommand{\SolverCADNIABlast}{\texttt{NIA-Blast}\xspace}

\newcommand{\SolverMCSATAF}{\texttt{MCSAT-AF}\xspace}
\newcommand{\SolverMCSATSMT}{\texttt{MCSAT-SMT}\xspace}

\newcommand{\SolverMCSATExFMICPOCNL}{\texttt{MCSAT-FMICPOCCAD}\xspace}
\newcommand{\SolverMCSATExFMICPVSOCNL}{\texttt{MCSAT-FMICPVSOCCAD}\xspace}
\newcommand{\SolverMCSATExFMOCNL}{\texttt{MCSAT-FMOCCAD}\xspace}
\newcommand{\SolverMCSATExFMVSOCNL}{\texttt{MCSAT-FMVSOCCAD}\xspace}
\newcommand{\SolverMCSATExNL}{\texttt{MCSAT-CAD}\xspace}
\newcommand{\SolverMCSATExOCNL}{\texttt{MCSAT-OCCAD}\xspace}

\newcommand{\SolverMCSATVOTF}{\texttt{MCSAT-Tf}\xspace}
\newcommand{\SolverMCSATVOBF}{\texttt{MCSAT-Bf}\xspace}
\newcommand{\SolverMCSATVORND}{\texttt{MCSAT-Rnd}\xspace}
\newcommand{\SolverMCSATVOUNIFORM}{\texttt{MCSAT-Uniform}\xspace}
\newcommand{\SolverMCSATVOUV}{\texttt{MCSAT-Univar}\xspace}
\newcommand{\SolverMCSATVOUVactive}{\texttt{MCSAT-Univar-active}\xspace}
\newcommand{\SolverMCSATVONLSAT}{\texttt{MCSAT-NLSAT}\xspace}
\newcommand{\SolverMCSATVOTFDYN}{\texttt{MCSAT-Tf-dynamic}\xspace}
\newcommand{\SolverMCSATVOUNIFORMTF}{\texttt{MCSAT-Uniform-Tf}\xspace}
